Subject: Re: linux-next: Tree for May 16 (security/landlock/ruleset.c)

From: Kees Cook <[email-masked]>
Date: Tue, 20 May 2025 09:44:06 -0700

On Mon, May 19, 2025 at 01:26:52PM -0700, Randy Dunlap wrote:
> 
> 
> > From 6fbf66fdfd0a7dac809b77faafdd72c60112bb8d Mon Sep 17 00:00:00 2001
> > From: Kees Cook <[email-masked]>
> > Date: Mon, 19 May 2025 11:52:06 -0700
> > Subject: [PATCH] string.h: Provide basic sanity checks for fallback memcpy()
> > MIME-Version: 1.0
> > Content-Type: text/plain; charset=UTF-8
> > Content-Transfer-Encoding: 8bit
> > 
> > Instead of defining memcpy() in terms of __builtin_memcpy() deep
> > in arch/x86/include/asm/string_32.h, notice that it is needed up in
> > the general string.h, as done with other common C String APIs. This
> > allows us to add basic sanity checking for pathological "size"
> > arguments to memcpy(). Besides the run-time checking benefit, this
> > avoids GCC trying to be very smart about value range tracking[1] when
> > CONFIG_PROFILE_ALL_BRANCHES=y but FORTIFY_SOURCE=n.
> > 
> > Link: https://lore.kernel.org/all/202505191117.C094A90F88@keescook/ [1]
> > Reported-by: kernel test robot <[email-masked]>
> > Closes: https://lore.kernel.org/all/[email-masked]/
> > Reported-by: Randy Dunlap <[email-masked]>
> > Closes: https://lore.kernel.org/all/[email-masked]/
> > Signed-off-by: Kees Cook <[email-masked]>
> 
> Tested-by: Randy Dunlap <[email-masked]>

I missed this when I sent out the proper patch. I'll add it locally.
Thanks!

-Kees

> 
> Thanks.
> 
> > ---
> > Cc: "Mickaël Salaün" <[email-masked]>
> > Cc: Thomas Gleixner <[email-masked]>
> > Cc: Ingo Molnar <[email-masked]>
> > Cc: Borislav Petkov <[email-masked]>
> > Cc: Dave Hansen <[email-masked]>
> > Cc: <[email-masked]>
> > Cc: "H. Peter Anvin" <[email-masked]>
> > Cc: Andy Shevchenko <[email-masked]>
> > Cc: Uros Bizjak <[email-masked]>
> > Cc: <[email-masked]>
> > ---
> >  arch/x86/include/asm/string_32.h |  6 ------
> >  include/linux/string.h           | 13 +++++++++++++
> >  2 files changed, 13 insertions(+), 6 deletions(-)
> > 
> > diff --git a/arch/x86/include/asm/string_32.h b/arch/x86/include/asm/string_32.h
> > index e9cce169bb4c..74397c95fa37 100644
> > --- a/arch/x86/include/asm/string_32.h
> > +++ b/arch/x86/include/asm/string_32.h
> > @@ -145,12 +145,6 @@ static __always_inline void *__constant_memcpy(void *to, const void *from,
> >  #define __HAVE_ARCH_MEMCPY
> >  extern void *memcpy(void *, const void *, size_t);
> >  
> > -#ifndef CONFIG_FORTIFY_SOURCE
> > -
> > -#define memcpy(t, f, n) __builtin_memcpy(t, f, n)
> > -
> > -#endif /* !CONFIG_FORTIFY_SOURCE */
> > -
> >  #define __HAVE_ARCH_MEMMOVE
> >  void *memmove(void *dest, const void *src, size_t n);
> >  
> > diff --git a/include/linux/string.h b/include/linux/string.h
> > index 01621ad0f598..ffcee31a14f9 100644
> > --- a/include/linux/string.h
> > +++ b/include/linux/string.h
> > @@ -3,6 +3,7 @@
> >  #define _LINUX_STRING_H_
> >  
> >  #include <linux/args.h>
> > +#include <linux/bug.h>
> >  #include <linux/array_size.h>
> >  #include <linux/cleanup.h>	/* for DEFINE_FREE() */
> >  #include <linux/compiler.h>	/* for inline */
> > @@ -390,7 +391,19 @@ static inline const char *kbasename(const char *path)
> >  
> >  #if !defined(__NO_FORTIFY) && defined(__OPTIMIZE__) && defined(CONFIG_FORTIFY_SOURCE)
> >  #include <linux/fortify-string.h>
> > +#else
> > +/* Basic sanity checking even without FORTIFY_SOURCE */
> > +# ifndef __HAVE_ARCH_MEMCPY
> > +#  define memcpy(t, f, n)					\
> > +	do {							\
> > +		typeof(n) __n = (n);				\
> > +		/* Skip impossible sizes. */			\
> > +		if (!WARN_ON(__n < 0 || __n == SIZE_MAX))	\
> > +			__builtin_memcpy(t, f, __n);		\
> > +	} while (0)
> > +# endif
> >  #endif
> > +
> >  #ifndef unsafe_memcpy
> >  #define unsafe_memcpy(dst, src, bytes, justification)		\
> >  	memcpy(dst, src, bytes)
> 
> -- 
> ~Randy

-- 
Kees Cook